OpenShot Audio Library | OpenShotAudio: juce::GZIPCompressorOutputStream Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::GZIPCompressorOutputStream Class Reference

`#include <juce_GZIPCompressorOutputStream.h>`

Inheritance diagram for juce::GZIPCompressorOutputStream:

## Public Types
enum | WindowBitsValues { windowBitsRaw = -15 , windowBitsGZIP = 15 + 16 }

## Public Member Functions
| GZIPCompressorOutputStream (OutputStream &destStream, int compressionLevel=-1, int windowBits=0)
| GZIPCompressorOutputStream (OutputStream *destStream, int compressionLevel=-1, bool deleteDestStreamWhenDestroyed=false, int windowBits=0)
| ~GZIPCompressorOutputStream () override
void | flush () override
int64 | getPosition () override
bool | setPosition (int64) override
bool | write (const void *, size_t) override
Public Member Functions inherited from juce::OutputStream
virtual | ~OutputStream ()
virtual void | flush ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual int64 | getPosition ()=0
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
virtual bool | writeByte (char byte)
virtual bool | writeBool (bool boolValue)
virtual bool | writeShort (short value)
virtual bool | writeShortBigEndian (short value)
virtual bool | writeInt (int value)
virtual bool | writeIntBigEndian (int value)
virtual bool | writeInt64 (int64 value)
virtual bool | writeInt64BigEndian (int64 value)
virtual bool | writeFloat (float value)
virtual bool | writeFloatBigEndian (float value)
virtual bool | writeDouble (double value)
virtual bool | writeDoubleBigEndian (double value)
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
virtual bool | writeCompressedInt (int value)
virtual bool | writeString (const String &text)
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
void | setNewLineString (const String &newLineString)
const String & | getNewLineString () const noexcept

## Detailed Description

A stream which uses zlib to compress the data written into it.

Important note: When you call flush() on a GZIPCompressorOutputStream, the gzip data is closed - this means that no more data can be written to it, and any subsequent attempts to call write() will cause an assertion.

See also
  GZIPDecompressorInputStream

Definition at line 38 of file juce_GZIPCompressorOutputStream.h.

## Member Enumeration Documentation

## ◆ WindowBitsValues

enum juce::GZIPCompressorOutputStream::WindowBitsValues

These are preset values that can be used for the constructor's windowBits parameter. For more info about this, see the zlib documentation for its windowBits parameter.

Definition at line 92 of file juce_GZIPCompressorOutputStream.h.

## Constructor & Destructor Documentation

## ◆ GZIPCompressorOutputStream() [1/2]

juce::GZIPCompressorOutputStream::GZIPCompressorOutputStream | ( | OutputStream & | destStream,
|  | int | compressionLevel = `-1`,
|  | int | windowBits = `0`
| ) |  |

Creates a compression stream.

Parameters

  destStream | the stream into which the compressed data will be written
  compressionLevel | how much to compress the data, between 0 and 9, where 0 is non-compressed storage, 1 is the fastest/lowest compression, and 9 is the slowest/highest compression. Any value outside this range indicates that a default compression level should be used.
  windowBits | this is used internally to change the window size used by zlib - leave it as 0 unless you specifically need to set its value for some reason

Definition at line 116 of file juce_GZIPCompressorOutputStream.cpp.

## ◆ GZIPCompressorOutputStream() [2/2]

juce::GZIPCompressorOutputStream::GZIPCompressorOutputStream | ( | OutputStream * | destStream,
|  | int | compressionLevel = `-1`,
|  | bool | deleteDestStreamWhenDestroyed = `false`,
|  | int | windowBits = `0`
| ) |  |

Creates a compression stream.

Parameters

  destStream | the stream into which the compressed data will be written. Ownership of this object depends on the value of deleteDestStreamWhenDestroyed
  compressionLevel | how much to compress the data, between 0 and 9, where 0 is non-compressed storage, 1 is the fastest/lowest compression, and 9 is the slowest/highest compression. Any value outside this range indicates that a default compression level should be used.
  deleteDestStreamWhenDestroyed | whether or not the GZIPCompressorOutputStream will delete the destStream object when it is destroyed
  windowBits | this is used internally to change the window size used by zlib - leave it as 0 unless you specifically need to set its value for some reason

Definition at line 121 of file juce_GZIPCompressorOutputStream.cpp.

## ◆ ~GZIPCompressorOutputStream()

juce::GZIPCompressorOutputStream::~GZIPCompressorOutputStream | ( |  | ) |
| override

Destructor.

Definition at line 128 of file juce_GZIPCompressorOutputStream.cpp.

## Member Function Documentation

## ◆ flush()

void juce::GZIPCompressorOutputStream::flush | ( |  | ) |
| overridevirtual

Flushes and closes the stream. Note that unlike most streams, when you call flush() on a GZIPCompressorOutputStream, the stream is closed - this means that no more data can be written to it, and any subsequent attempts to call write() will cause an assertion.

Implements juce::OutputStream.

Definition at line 133 of file juce_GZIPCompressorOutputStream.cpp.

Referenced by ~GZIPCompressorOutputStream().

## ◆ getPosition()

int64 juce::GZIPCompressorOutputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the stream's current position.

See also
  setPosition

Implements juce::OutputStream.

Definition at line 146 of file juce_GZIPCompressorOutputStream.cpp.

## ◆ setPosition()

bool juce::GZIPCompressorOutputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements juce::OutputStream.

Definition at line 151 of file juce_GZIPCompressorOutputStream.cpp.

## ◆ write()

bool juce::GZIPCompressorOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| overridevirtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements juce::OutputStream.

Definition at line 139 of file juce_GZIPCompressorOutputStream.cpp.

The documentation for this class was generated from the following files:

- juce_GZIPCompressorOutputStream.h
- juce_GZIPCompressorOutputStream.cpp